SystemOrganization addCategory: #'Mustache-Seaside'!
SystemOrganization addCategory: #'Mustache-Seaside-Lib'!
SystemOrganization addCategory: #'Mustache-Seaside-Example'!

WAFileLibrary subclass: #JQMustacheLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Lib'!

!JQMustacheLibrary methodsFor: 'uploaded' stamp: 'JesusMari 2/8/2013 16:40'!
mustacheJs
	^ '/*!!
 * mustache.js - Logic-less {{mustache}} templates with JavaScript
 * http://github.com/janl/mustache.js
 */

/*global define: false*/

(function (root, factory) {
  if (typeof exports === "object" && exports) {
    module.exports = factory; // CommonJS
  } else if (typeof define === "function" && define.amd) {
    define(factory); // AMD
  } else {
    root.Mustache = factory; // <script>
  }
}(this, (function () {

  var exports = {};

  exports.name = "mustache.js";
  exports.version = "0.7.2";
  exports.tags = ["{{", "}}"];

  exports.Scanner = Scanner;
  exports.Context = Context;
  exports.Writer = Writer;

  var whiteRe = /\s*/;
  var spaceRe = /\s+/;
  var nonSpaceRe = /\S/;
  var eqRe = /\s*=/;
  var curlyRe = /\s*\}/;
  var tagRe = /#|\^|\/|>|\{|&|=|!!/;

  var _test = RegExp.prototype.test;
  var _toString = Object.prototype.toString;

  // Workaround for https://issues.apache.org/jira/browse/COUCHDB-577
  // See https://github.com/janl/mustache.js/issues/189
  function testRe(re, string) {
    return _test.call(re, string);
  }

  function isWhitespace(string) {
    return !!testRe(nonSpaceRe, string);
  }

  var isArray = Array.isArray || function (obj) {
    return _toString.call(obj) === ''[object Array]'';
  };

  function escapeRe(string) {
    return string.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g, "\\$&");
  }

  var entityMap = {
    "&": "&amp;",
    "<": "&lt;",
    ">": "&gt;",
    ''"'': ''&quot;'',
    "''": ''&#39;'',
    "/": ''&#x2F;''
  };

  function escapeHtml(string) {
    return String(string).replace(/[&<>"''\/]/g, function (s) {
      return entityMap[s];
    });
  }

  // Export the escaping function so that the user may override it.
  // See https://github.com/janl/mustache.js/issues/244
  exports.escape = escapeHtml;

  function Scanner(string) {
    this.string = string;
    this.tail = string;
    this.pos = 0;
  }

  /**
   * Returns `true` if the tail is empty (end of string).
   */
  Scanner.prototype.eos = function () {
    return this.tail === "";
  };

  /**
   * Tries to match the given regular expression at the current position.
   * Returns the matched text if it can match, the empty string otherwise.
   */
  Scanner.prototype.scan = function (re) {
    var match = this.tail.match(re);

    if (match && match.index === 0) {
      this.tail = this.tail.substring(match[0].length);
      this.pos += match[0].length;
      return match[0];
    }

    return "";
  };

  /**
   * Skips all text until the given regular expression can be matched. Returns
   * the skipped string, which is the entire tail if no match can be made.
   */
  Scanner.prototype.scanUntil = function (re) {
    var match, pos = this.tail.search(re);

    switch (pos) {
    case -1:
      match = this.tail;
      this.pos += this.tail.length;
      this.tail = "";
      break;
    case 0:
      match = "";
      break;
    default:
      match = this.tail.substring(0, pos);
      this.tail = this.tail.substring(pos);
      this.pos += pos;
    }

    return match;
  };

  function Context(view, parent) {
    this.view = view;
    this.parent = parent;
    this._cache = {};
  }

  Context.make = function (view) {
    return (view instanceof Context) ? view : new Context(view);
  };

  Context.prototype.push = function (view) {
    return new Context(view, this);
  };

  Context.prototype.lookup = function (name) {
    var value = this._cache[name];

    if (!!value) {
      if (name == ''.'') {
        value = this.view;
      } else {
        var context = this;

        while (context) {
          if (name.indexOf(''.'') > 0) {
            value = context.view;
            var names = name.split(''.''), i = 0;
            while (value && i < names.length) {
              value = value[names[i++]];
            }
          } else {
            value = context.view[name];
          }

          if (value !!= null) break;

          context = context.parent;
        }
      }

      this._cache[name] = value;
    }

    if (typeof value === ''function'') value = value.call(this.view);

    return value;
  };

  function Writer() {
    this.clearCache();
  }

  Writer.prototype.clearCache = function () {
    this._cache = {};
    this._partialCache = {};
  };

  Writer.prototype.compile = function (template, tags) {
    var fn = this._cache[template];

    if (!!fn) {
      var tokens = exports.parse(template, tags);
      fn = this._cache[template] = this.compileTokens(tokens, template);
    }

    return fn;
  };

  Writer.prototype.compilePartial = function (name, template, tags) {
    var fn = this.compile(template, tags);
    this._partialCache[name] = fn;
    return fn;
  };

  Writer.prototype.getPartial = function (name) {
    if (!!(name in this._partialCache) && this._loadPartial) {
      this.compilePartial(name, this._loadPartial(name));
    }

    return this._partialCache[name];
  };

  Writer.prototype.compileTokens = function (tokens, template) {
    var self = this;
    return function (view, partials) {
      if (partials) {
        if (typeof partials === ''function'') {
          self._loadPartial = partials;
        } else {
          for (var name in partials) {
            self.compilePartial(name, partials[name]);
          }
        }
      }

      return renderTokens(tokens, self, Context.make(view), template);
    };
  };

  Writer.prototype.render = function (template, view, partials) {
    return this.compile(template)(view, partials);
  };

  /**
   * Low-level function that renders the given `tokens` using the given `writer`
   * and `context`. The `template` string is only needed for templates that use
   * higher-order sections to extract the portion of the original template that
   * was contained in that section.
   */
  function renderTokens(tokens, writer, context, template) {
    var buffer = '''';

    var token, tokenValue, value;
    for (var i = 0, len = tokens.length; i < len; ++i) {
      token = tokens[i];
      tokenValue = token[1];

      switch (token[0]) {
      case ''#'':
        value = context.lookup(tokenValue);

        if (typeof value === ''object'') {
          if (isArray(value)) {
            for (var j = 0, jlen = value.length; j < jlen; ++j) {
              buffer += renderTokens(token[4], writer, context.push(value[j]), template);
            }
          } else if (value) {
            buffer += renderTokens(token[4], writer, context.push(value), template);
          }
        } else if (typeof value === ''function'') {
          var text = template == null ? null : template.slice(token[3], token[5]);
          value = value.call(context.view, text, function (template) {
            return writer.render(template, context);
          });
          if (value !!= null) buffer += value;
        } else if (value) {
          buffer += renderTokens(token[4], writer, context, template);
        }

        break;
      case ''^'':
        value = context.lookup(tokenValue);

        // Use JavaScript''s definition of falsy. Include empty arrays.
        // See https://github.com/janl/mustache.js/issues/186
        if (!!value || (isArray(value) && value.length === 0)) {
          buffer += renderTokens(token[4], writer, context, template);
        }

        break;
      case ''>'':
        value = writer.getPartial(tokenValue);
        if (typeof value === ''function'') buffer += value(context);
        break;
      case ''&'':
        value = context.lookup(tokenValue);
        if (value !!= null) buffer += value;
        break;
      case ''name'':
        value = context.lookup(tokenValue);
        if (value !!= null) buffer += exports.escape(value);
        break;
      case ''text'':
        buffer += tokenValue;
        break;
      }
    }

    return buffer;
  }

  /**
   * Forms the given array of `tokens` into a nested tree structure where
   * tokens that represent a section have two additional items: 1) an array of
   * all tokens that appear in that section and 2) the index in the original
   * template that represents the end of that section.
   */
  function nestTokens(tokens) {
    var tree = [];
    var collector = tree;
    var sections = [];

    var token;
    for (var i = 0, len = tokens.length; i < len; ++i) {
      token = tokens[i];
      switch (token[0]) {
      case ''#'':
      case ''^'':
        sections.push(token);
        collector.push(token);
        collector = token[4] = [];
        break;
      case ''/'':
        var section = sections.pop();
        section[5] = token[2];
        collector = sections.length > 0 ? sections[sections.length - 1][4] : tree;
        break;
      default:
        collector.push(token);
      }
    }

    return tree;
  }

  /**
   * Combines the values of consecutive text tokens in the given `tokens` array
   * to a single token.
   */
  function squashTokens(tokens) {
    var squashedTokens = [];

    var token, lastToken;
    for (var i = 0, len = tokens.length; i < len; ++i) {
      token = tokens[i];
      if (token) {
        if (token[0] === ''text'' && lastToken && lastToken[0] === ''text'') {
          lastToken[1] += token[1];
          lastToken[3] = token[3];
        } else {
          lastToken = token;
          squashedTokens.push(token);
        }
      }
    }

    return squashedTokens;
  }

  function escapeTags(tags) {
    return [
      new RegExp(escapeRe(tags[0]) + "\\s*"),
      new RegExp("\\s*" + escapeRe(tags[1]))
    ];
  }

  /**
   * Breaks up the given `template` string into a tree of token objects. If
   * `tags` is given here it must be an array with two string values: the
   * opening and closing tags used in the template (e.g. ["<%", "%>"]). Of
   * course, the default is to use mustaches (i.e. Mustache.tags).
   */
  exports.parse = function (template, tags) {
    template = template || '''';
    tags = tags || exports.tags;

    if (typeof tags === ''string'') tags = tags.split(spaceRe);
    if (tags.length !!== 2) throw new Error(''Invalid tags: '' + tags.join('', ''));

    var tagRes = escapeTags(tags);
    var scanner = new Scanner(template);

    var sections = [];     // Stack to hold section tokens
    var tokens = [];       // Buffer to hold the tokens
    var spaces = [];       // Indices of whitespace tokens on the current line
    var hasTag = false;    // Is there a {{tag}} on the current line?
    var nonSpace = false;  // Is there a non-space char on the current line?

    // Strips all whitespace tokens array for the current line
    // if there was a {{#tag}} on it and otherwise only space.
    function stripSpace() {
      if (hasTag && !!nonSpace) {
        while (spaces.length) {
          delete tokens[spaces.pop()];
        }
      } else {
        spaces = [];
      }

      hasTag = false;
      nonSpace = false;
    }

    var start, type, value, chr, token;
    while (!!scanner.eos()) {
      start = scanner.pos;

      // Match any text between tags.
      value = scanner.scanUntil(tagRes[0]);
      if (value) {
        for (var i = 0, len = value.length; i < len; ++i) {
          chr = value.charAt(i);

          if (isWhitespace(chr)) {
            spaces.push(tokens.length);
          } else {
            nonSpace = true;
          }

          tokens.push([''text'', chr, start, start + 1]);
          start += 1;

          // Check for whitespace on the current line.
          if (chr == ''\n'') stripSpace();
        }
      }

      // Match the opening tag.
      if (!!scanner.scan(tagRes[0])) break;
      hasTag = true;

      // Get the tag type.
      type = scanner.scan(tagRe) || ''name'';
      scanner.scan(whiteRe);

      // Get the tag value.
      if (type === ''='') {
        value = scanner.scanUntil(eqRe);
        scanner.scan(eqRe);
        scanner.scanUntil(tagRes[1]);
      } else if (type === ''{'') {
        value = scanner.scanUntil(new RegExp(''\\s*'' + escapeRe(''}'' + tags[1])));
        scanner.scan(curlyRe);
        scanner.scanUntil(tagRes[1]);
        type = ''&'';
      } else {
        value = scanner.scanUntil(tagRes[1]);
      }

      // Match the closing tag.
      if (!!scanner.scan(tagRes[1])) throw new Error(''Unclosed tag at '' + scanner.pos);

      token = [type, value, start, scanner.pos];
      tokens.push(token);

      if (type === ''#'' || type === ''^'') {
        sections.push(token);
      } else if (type === ''/'') {
        // Check section nesting.
        if (sections.length === 0) throw new Error(''Unopened section "'' + value + ''" at '' + start);
        var openSection = sections.pop();
        if (openSection[1] !!== value) throw new Error(''Unclosed section "'' + openSection[1] + ''" at '' + start);
      } else if (type === ''name'' || type === ''{'' || type === ''&'') {
        nonSpace = true;
      } else if (type === ''='') {
        // Set the tags for the next time around.
        tags = value.split(spaceRe);
        if (tags.length !!== 2) throw new Error(''Invalid tags at '' + start + '': '' + tags.join('', ''));
        tagRes = escapeTags(tags);
      }
    }

    // Make sure there are no open sections when we''re done.
    var openSection = sections.pop();
    if (openSection) throw new Error(''Unclosed section "'' + openSection[1] + ''" at '' + scanner.pos);

    tokens = squashTokens(tokens);

    return nestTokens(tokens);
  };

  // All Mustache.* functions use this writer.
  var _writer = new Writer();

  /**
   * Clears all cached templates and partials in the default writer.
   */
  exports.clearCache = function () {
    return _writer.clearCache();
  };

  /**
   * Compiles the given `template` to a reusable function using the default
   * writer.
   */
  exports.compile = function (template, tags) {
    return _writer.compile(template, tags);
  };

  /**
   * Compiles the partial with the given `name` and `template` to a reusable
   * function using the default writer.
   */
  exports.compilePartial = function (name, template, tags) {
    return _writer.compilePartial(name, template, tags);
  };

  /**
   * Compiles the given array of tokens (the output of a parse) to a reusable
   * function using the default writer.
   */
  exports.compileTokens = function (tokens, template) {
    return _writer.compileTokens(tokens, template);
  };

  /**
   * Renders the `template` with the given `view` and `partials` using the
   * default writer.
   */
  exports.render = function (template, view, partials) {
    return _writer.render(template, view, partials);
  };

  // This is here for backwards compatibility with 0.4.x.
  exports.to_html = function (template, view, partials, send) {
    var result = exports.render(template, view, partials);

    if (typeof send === "function") {
      send(result);
    } else {
      return result;
    }
  };

  return exports;

}())));

'! !

!JQMustacheLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:42'!
selectorsToInclude
	^ #(#mustacheJs)! !

WAFileLibrary subclass: #JQMustacheOnLineLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Lib'!

!JQMustacheOnLineLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 22:10'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://github.com/janl/mustache.js/raw/master/mustache.js'! !

MustacheTemplate subclass: #MustacheCounterTemplate
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!MustacheCounterTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:22'!
render
^'<h1>Mustache Counter:{{counter}}</h1>

<p>Hello "Seaside code" passed through a View to Mustache </p>

{{[
	html paragraph:''Hello again from seaside inside a square bracket''.
	html paragraph:aView asString.
	html anchor
			callback:[aView instance increase];
			with: ''++''.
			
	html space.
	html anchor
			callback:[aView instance decrease];
			with: ''--''.							
]}}

{{>Partial3}}'! !

MustacheCounterTemplate subclass: #Partial3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!Partial3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:06'!
render

^'{{[ 
		html heading: (aView at:''counter'').
	]}}'! !

!WAHtmlCanvas methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/5/2012 15:36'!
mustache
	^ ( WAMustacheTag on:self)! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/9/2012 08:58'!
html
	^ html! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/3/2012 10:55'!
html: aHtmlCanvas
	html:=aHtmlCanvas! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/8/2012 08:31'!
renderTemplateAt: aTemplate view:aView on:htmlCanvas
"High-level function that renders the given 'template' located in the partials node, using the given 'view'  If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "

self html:htmlCanvas.
^ self render: (self class clearComma:(self at:aTemplate)) view:aView.! !

WAExampleComponent subclass: #MustacheCounter
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:51'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter class methodsFor: 'examples' stamp: 'JesusMari 12/3/2012 11:08'!
example
	^ self new! !

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:50'!
handlerName
	^ 'examples/mustacheCounter'! !

!MustacheCounter class methodsFor: 'initialization' stamp: 'JesusMari 12/3/2012 11:08'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count
	^ count! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count: anInteger
	count := anInteger! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
decrease
	count := count - 1! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
increase
	count := count + 1! !

!MustacheCounter methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 15:37'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter methodsFor: 'rendering' stamp: 'JesusMari 2/18/2013 13:38'!
renderContentOn: html
"Server side rendered mustache"
	html mustache 
			basePath:'D:\smalltalk\SCouchViewServer\templates\';
			template:'counter';
			view: (JsonObject fromAssociations: {
						'counter'-> self count.
						'seasideContent'->[:stack : htmlCanvas|
							htmlCanvas heading: count.
							htmlCanvas anchor
								callback: [ self increase ];
								with: '++'.
							htmlCanvas space.
							htmlCanvas anchor
								callback: [ self decrease ];
								with: '--'
							]
					}).
	! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
states
	^ Array with: self! !

WAExampleComponent subclass: #MustacheCounter2
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Example'!

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter2 class methodsFor: 'examples' stamp: 'JesusMari 12/5/2012 16:07'!
example
	^ self new! !

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:20'!
handlerName
	^ 'examples/mustacheCounter2'! !

!MustacheCounter2 class methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count
	^ count! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count: anInteger
	count := anInteger! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
decrease
	count := count - 1! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
increase
	count := count + 1! !

!MustacheCounter2 methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter2 methodsFor: 'rendering' stamp: 'JesusMari 12/15/2012 17:22'!
renderContentOn: html

	html mustache 
			template:MustacheCounterTemplate;
			view: (JsonObject fromAssociations: {
						'counter'->self count.
						'instance'->self  .
					}).
	! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
states
	^ Array with: self! !

!JQueryInstance methodsFor: '*mustache-seaside' stamp: 'JesusMari 2/9/2013 21:25'!
mustache: aTemplate data:theData
	"returns function call to renderize Mustache template."
	
self call:'append' with:((JSStream on:'Mustache') call:'to_html'
			 			with:(aTemplate)
						with:(JSStream on:(self render: theData)))! !

!JQueryInstance methodsFor: '*mustache-seaside' stamp: 'JesusMari 2/9/2013 21:21'!
mustache: aTemplate data:theData command:aString
	"returns function call to renderize Mustache template."
	
self call:aString with:((JSStream on:'Mustache') call:'to_html'
			 			with:(aTemplate)
						with:(JSStream on:(self render: theData)))! !

!JQueryInstance methodsFor: '*mustache-seaside' stamp: 'JesusMari 2/9/2013 21:25'!
mustache: aTemplate data:theData partials:anArrayOfPartials
	"returns function call to renderize Mustache template."

self call:'append' with:((JSStream on:'Mustache') call:'to_html'
			 	with:(aTemplate)
				with:(JSStream on:(self render: theData))
				with:(anArrayOfPartials)
				)! !

!JQueryInstance methodsFor: '*mustache-seaside' stamp: 'JesusMari 2/18/2013 13:58'!
mustache: aTemplate data:theData partials:anArrayOfPartials command:anString
	"returns function call to renderize Mustache template.
	'how'' must be append after "

self call:anString with:((JSStream on:'Mustache') call:'to_html'
			 	with:(aTemplate)
				with:(JSStream on:(self render: theData))
				with:(anArrayOfPartials)
				)! !

Object subclass: #WAMustacheSectionTag
	instanceVariableNames: 'inverted html name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside'!

!WAMustacheSectionTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:32'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html
	^ html! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html: anObject
	html := anObject! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:43'!
initialize
inverted:=false! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
inverted
inverted:=true! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:39'!
name:aSectionName
name:=aSectionName! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
with:aBlock
self html  flush.
self html document nextPutAll: (inverted ifFalse:['{{#',name,'}}'] ifTrue:['{{^',name,'}}']).
self html  flush.
aBlock value.
self html  flush.
self html document nextPutAll: '{{/',name,'}}'.! !

Object subclass: #WAMustacheTag
	instanceVariableNames: 'mustacheInstance template html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside'!

!WAMustacheTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:03'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 15:42'!
InvertedSection
^ (WAMustacheSectionTag on:html) inverted! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:33'!
basePath: aCompletePath
mustacheInstance ifNil:[mustacheInstance:=Mustache instanceFromFolder:aCompletePath]
! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 2/5/2013 18:15'!
html
^html! !

!WAMustacheTag methodsFor: 'private' stamp: 'JesusMari 12/5/2012 15:41'!
html: aCanvas
html:=aCanvas! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:13'!
includePartial:aPartialName
self html flush.
self html document nextPutAll: '{{>',aPartialName,'}}'! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 15:38'!
section
^ WAMustacheSectionTag on:html! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 2/5/2013 18:07'!
template
^template! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 12/5/2012 15:24'!
template:aTemplate
template:=aTemplate! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:29'!
template:aTemplate view:aView
self template:aTemplate.
self view:aView.
! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
unescapedVariable:aName

^'{{&',aName,'}}'! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
variable:aName
^'{{',aName,'}}'! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 16:27'!
view: aView
(template isKindOf:String) ifTrue:[
	mustacheInstance renderTemplateAt: template view:aView on:html.
	].
(template class superclass = MustacheTemplate class)  ifTrue:[
	Mustache toHtml: template view:aView on:html.
	]! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 22:24'!
with: aBlock
self html flush.
self html document nextPutAll:'<script id="'.
self html document nextPutAll: self template.
self html document nextPutAll:'" type="text/x-jquery-tmpl">'.
aBlock value.
self html document nextPutAll:'</script>'.
self html flush.! !
MustacheCounter2 initialize!
MustacheCounter initialize!
